/*
 * Charlieplexing gwiazdki
 *
 *   SylwekK
 *   19-12-2018
 *
 *   ATTINY13 9,6MHz
 *   fusy: 7A, FF
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

//*******************************************************************************
uint8_t pwm[12];		//liczniki PWM
volatile uint8_t lum[12];	//tablica jasnoci, PWM 16 poziomw (0-15) TU SI STERUJE JASNOCI
//----------------------
//tablica charlieplexing
//4sb-DDRB, 4mb-PORT
const uint8_t sel[] PROGMEM = {
    0b00110001,
    0b00110010,
    0b01100010,
    0b01100100,
    0b11000100,
    0b11001000,
    0b01010001,
    0b01010100,
    0b10100010,
    0b10101000,
    0b10010001,
    0b10011000
}; //0,1,2,3,4,5,6,7,8,9,10,11
#define SEL(x) pgm_read_byte(&sel[x])	//mae udogodnienie :)

volatile uint8_t timer;
uint8_t r;

//---------------------------------------------------------------------------------------------
void led_on(uint8_t nr)
{
  DDRB=(SEL(nr)>>4); //wycignicie 4-ech starszych bitw na pozycj modszych
  PORTB=(SEL(nr) & 0b00001111); //uwzgldnij tylko 4 modsze bity
}

#define led_off DDRB=0; PORTB=0;

//---------------------------------------------------------------------------------------------


//----dane dla efektu gwiazdek----

const uint8_t PROGMEM led[] = {6,1,3,9,5,11,4,8,2,7,0,10};	//kolejno rozpalania led (dowolna w zakresie 0-11)
#define LED(x) pgm_read_byte(&led[x])

uint8_t speed;	//prdko zapalania kolejnej led
uint8_t tled;	//licznik tablicy led
uint16_t kier;	//przechowanie kierunku efektu (ciemnianie/rozjanianie) bity 0-11, 0-ciamniaj, 1-rozjaniaj

//--------------------------------


//*******************************************************************************
int main(void)
{
  //------------------------------------------
  //ustawienie przerwa
   TCCR0A |= (1<<WGM01); //CTC
 //  TCCR0B |= (1<<CS00); //Prescale 1
   TCCR0B |= (1<<CS01);  //Prescale 8
   TIMSK0 |= (1<<OCIE0A);//zezwolenie na przerwanie CompareMatch
//   OCR0A=119;            //10khz przy 9,6Mhz /8 (okres 100us)
   OCR0A=59;            //20khz przy 9,6Mhz /8 (okres 50us)
//   OCR0A=29;            //40khz przy 9,6Mhz /8 (okres 25us)
  //------------------------------------------
  sei();
  while(1)
    {
      if(!timer)
	{
	  timer=80;	//prdko efektu (1=1ms)
	  if(!speed--)
	    {
	      speed=3;	//odstp mnidzy zapalaniem led
	      kier |= (1<<LED(tled));
	      tled++; if(tled==12) tled = 0;
	    }
	  for(uint8_t x=0; x<12; x++)
	    {
	      if((lum[x] < 15) && (kier & (1<<x))) lum[x]++;
	      if(lum[x] && !(kier & (1<<x))) lum[x]--;
	      if(lum[x] == 11) kier &= ~(1<<x);
	    }
	}
    }//END while
}// END main
//*******************************************************************************
//*******************************************************************************
ISR(TIM0_COMPA_vect)
{
  static uint8_t r, tp;
  if(tp++ == 20)
    {
      tp=0;
      if(timer) timer--;
    }

  //--------------------------------
  //cykliczne zapalanie kadej diody z uwzgldnieniem jej luminacji
  led_off;	//wyczenie diod
  if (lum[r] > pwm[r]) led_on(r);	//tu jest zarzdzanie jasnoci (PWM)
  if (pwm[r]++ > 15) pwm[r]=0;
  if(r++ > 11) r=0;
  //--------------------------------

}
//*******************************************************************************
//*******************************************************************************


